
#include "cpl.h"

__attribute__((noinline))
int isqrt(int num) {
	int res = 0;
	int bit = 1 << 30; // The second-to-top bit is set: 1 << 30 for 32 bits
 
	// "bit" starts at the highest power of four <= the argument.
	while (bit > num)
		bit >>= 2;
		
	while (bit != 0) {
		if (num >= res + bit) {
			num -= res + bit;
			res = (res >> 1) + bit;
		}
		else {
			res >>= 1;
		}
		bit >>= 2;
	}
	return res;
}

int cpl_main() {
	dump_int(isqrt(9));
	dump_int(isqrt(25));
	dump_int(isqrt(50));
	dump_int(isqrt(37));
	return 0;
}

